# Quorum Entropy Ceremony

This is a ceremony for generating entropy which is used to derive Quorum PGP keys, load them into smart cards and shard entropy to them. Optionally a disaster recovery PGP key can be derived.

- [ ] add step for deriving root entropy pgp key 

## Requirements

{{ #include ../../operator-requirements.md:requirements }}

*  `N` SD cards in the chosen `M of N` quorum

* [Ceremony SD Card](../provisioner/provision-root-entropy-ceremony-sd-card.md)

* [Quorum Entropy Ceremony SD Card](../provisioner/provision-quorum-ceremony-sd-card.md)

* [High Visibility Storage](TODO): plastic container or bag that's used to keep items while not in use in a visible location like the middle of a desk.

## Procedure 

1. Enter the designated location with at least 2 operators and all required equipment

1. Lock access to the location - there should be no inflow or outflow of people during the ceremony

1. Retrieve Air-Gapped Bundle from locked storage

### Unsealing Tamper Proofing

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

1. Place all materials except for the laptop into High Visibility Storage

### Generating Entropy

1. Retrieve AirgapOS SD card from High Visibility Storage and plug it into air-gapped laptop 

1. Turn on the machine

1. Once booted, remove the AirgapOS SD card and place it into High Visibility Storage

1. Plug in the Ceremony SD card 

1. Run `ceremony.sh` from the SD card

1. Button mash to ensure adequate entropy on the OS

1. Back up the `shardfile` to any desired number of SD cards, and label each "Shardfile [date]"

1. Optionally write an `autorun.sh` file to the Shardfile SD card containing the following command:

    * `keyfork recover shard --daemon`

1. If an OpenPGP certificate was derived, store the public key on a SD card, separate from the shardfiles

### Finalizing Ceremony

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

    * Shardfile SD card

    * Ceremony SD card

{{ #include ../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}